import math
import pygame
from pygame.locals import *

SW,SH = 740,180

def part1(data,dest):
    rect = pygame.Rect(76,18,144,144)
    cx,cy,r = rect.centerx,rect.centery,rect.w/2
    p = [(cx,cy)]
    total = max(1,data[0]+data[1])
    a = (360*data[1]/total)+1
    for n in range(145-(a/2),145+(a/2)):
        x = cx+int(r*math.cos(n*math.pi/180))
        y = cy+int(r*math.sin(n*math.pi/180))
        p.append((x,y))
    p.append((cx,cy))
    if len(p) > 2:
        pygame.draw.polygon(dest,(0,0,0),p)

def part2(data,dest):
    mx = max(1,max(data))
    n = 0
    for r in [
        pygame.Rect(306,66,22,86),
        pygame.Rect(361,66,22,86),
        pygame.Rect(408,65,22,86)
        ]:
        h = r.h * data[n] / mx
        r.y,r.h = r.y+r.h-h,h
        dest.fill((0,0,0),r)
        n += 1

def part3(data,dest):
    r = pygame.Rect(527,82,190,46)
    img = pygame.transform.smoothscale(data,(r.w,r.h))
    dest.blit(img,(r.x,r.y))

def next(src,base):
    data3,dest = src.convert(),base.convert()
    data1 = [0,0]
    data2 = [0,0,0]
    for y in xrange(0,src.get_height()):
        for x in xrange(0,src.get_width()):
            c = src.get_at((x,y))[0]
            data1[0] += c
            data1[1] += 255-c
            data2[int(x/247)] += 255-c
    part1(data1,dest)
    part2(data2,dest)
    part3(data3,dest)
    return dest

def main():
    screen = pygame.display.set_mode((SW,SH),0,32)
    base = pygame.image.load('base.png').convert()
    orig = pygame.image.load('self_description.png').convert()
    
    #A few alternate starting points
    #screen.fill((0,0,0)) # 6 iterations
    #screen.fill((255,255,255)) # 5 iterations
    screen.blit(pygame.transform.smoothscale(pygame.image.load('xkcdLogo.png'),(SW,SH)),(0,0)) # 4 iterations
    
    cur = screen.convert()
    n = 0
    total=0

    _quit = False
    while not _quit:
        for e in pygame.event.get():
            if e.type is KEYDOWN and e.key == K_ESCAPE:
                _quit = True
                break
            if e.type is QUIT:
                _quit = True
                break
            if e.type is KEYDOWN:
                cur = next(cur,base)
                total += 1
        if (n%2) == 0: screen.blit(orig,(0,0))
        else: screen.blit(cur,(0,0))
        pygame.display.flip()
        pygame.time.wait(100)
        n += 1
    print total

if __name__ == '__main__':
    main()